commit 103f8884d7b3b2bbca8e70da0fade38f674a845c
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Wed Oct 30 15:01:01 2024 +0530

    PS-9434 MySQL server heap-buffer-overflow in strlen
    
    https://perconadev.atlassian.net/browse/PS-9434
    
    Bug#36593265 mysql/mysql-server@c6997b13cfa
    
    When converting a MySQL String to an std::string,
    use {ptr(), length()} rather than strlen().
    
    Change-Id: Ie59965ecccf9846cf5c18b90b572328263c1cefa

diff --git a/sql/item_strfunc.cc b/sql/item_strfunc.cc
index 653862c953c..3d6c88b344a 100644
--- a/sql/item_strfunc.cc
+++ b/sql/item_strfunc.cc
@@ -1,5 +1,5 @@
 /*
-   Copyright (c) 2000, 2023, Oracle and/or its affiliates.
+   Copyright (c) 2000, 2024, Oracle and/or its affiliates.
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2.0,
@@ -435,7 +435,7 @@ class kdf_argument {
       *error_generated = TRUE;
       return FALSE;
     }
-    kdf_option = kdf_option_value->ptr();
+    kdf_option = string(kdf_option_value->ptr(), kdf_option_value->length());
     return TRUE;
   }
 

